namespace eval ActiveRecord {
	variable associations
	set associations {
		{department  has_many    users     }
		{user        belongs_to  department}
		{user        has_many    entries   }
		{user        has_many    comments  }
		{category    has_many    entries   }
		{entry       belongs_to  category  }
		{entry       belongs_to  user      }
		{entry       has_many    comments  }
		{comment     belongs_to  entry     }
		{comment     belongs_to  user      }
	}
}
