package require struct::list

namespace eval enumerable {}

proc enumerable::map {body varlist values} {
	set res {}
	foreach valuelist $values {
		foreach $varlist $valuelist {
			lappend res [eval $body]
		}
	}
	return $res
}

proc enumerable::select {body varlist values} {
	set res1 {}
	foreach valuelist $values {
		foreach $varlist $valuelist {
			if [eval [join $body]] {
				set res2 {}
				foreach var $varlist {
					lappend res2 [subst $$var]
				}
				lappend res1 $res2
			}
		}
	}
	return $res1
}

proc enumerable::sort_by {body varlist values} {
	foreach valuelist $values {
		set cnt 0
		foreach $varlist $valuelist {
			foreach var $varlist {
				lappend res1([eval $body],$cnt) [subst $$var]
			}
			incr cnt
		}
	}
	set res2 {}
	foreach m [lsort -dictionary [array names res1]] {
		lappend res2 $res1($m)
	}
	return $res2
}

package provide enumerable 0.1
