package require XOTcl
namespace import xotcl::*

Class ExtendedMetaclass

ExtendedMetaclass instproc new {args} {
	parse_options options args
	if {[info exists options(-childof)]} {
		set childof $options(-childof)
		array unset options -childof
	} else {
		set childof [self]
	}
	if {[set volatile [info exists options(-volatile)]]} {
		array unset options -volatile
	}
	set autoname [eval next [array get options]]
	set renamed [namespace qualifier $autoname]::[regsub {#} [namespace tail $autoname] {}]
	$autoname move $renamed
	set object ${childof}::[namespace tail $renamed]
	$renamed move $object
	if {$volatile} {$object volatile}
	if [catch {
		$object mixin [self]InstanceMethods
	}] {
		if [catch {
			$object mixin [namespace qualifier [self]]::InstanceMethods
		}] {
			catch {
				$object mixin InstanceMethods
			}
		}
	}
	$object proc cset {args} {
		eval [my class] set $args
	}
	$object init
	return $object
}

package provide extended_metaclass 0.1
